#ifndef __APP_WIRELESS_PAIR_H__
#define __APP_WIRELESS_PAIR_H__

#ifdef __cplusplus
extern "C" {
#endif

/*Includes ------------------------------------------------------*/
#include <stdbool.h>
#include <stdint.h>
#include <string.h>
#include "sdk_common.h"
#include "SEGGER_RTT.h"
#include "usr_config.h"

/*Private macro ------------------------------------------------------------------------------------------------------------------------------------*/
/*Struction ----------------------------------------------------*/
//¼ö
typedef enum _app_wireless_pair_event
{
	APP_WIRELESS_PAIR_EVENT_CHARGING_INSERTING,																																		//
	APP_WIRELESS_PAIR_EVENT_CHARGING_UNPLUG,																																			//γ
	APP_WIRELESS_PAIR_EVENT_RSSI_MEETS_REQUIREMENTS,                                            									//rssiҪ
	APP_WIRELESS_PAIR_EVENT_RSSI_DOES_NOT_MEETS_REQUIREMENTS, 																										//rssiҪ
	APP_WIRELESS_PAIR_EVENT_PAIR_DONE,																																						//																
}App_Wireless_Pair_Event_e;

//״̬ݵö
typedef enum _app_wireless_pair_state
{
	APP_WIRELESS_PAIR_STATE_PAIRING_STANDBY,																																			//Դ״̬
	APP_WIRELESS_PAIR_STATE_PAIRING_PREPARATION,																																	//׼״̬
	APP_WIRELESS_PAIR_STATE_PAIRING_IN_PROGRESS,																																	//Խ״̬
	APP_WIRELESS_PAIR_STATE_END_OF_PAIRING,																																				//Խ״̬
}App_Wireless_Pair_State_e;

typedef int (*App_Wireless_Pair_Set_Scan_Cb)(int on_off);

typedef int (*App_Wireless_Pair_Set_Adv_Cb)(int on_off);
/*API -------------------------------------------------------*/
/**
	@brief 		ʼӦ
	@param 		
	@return 						- [out]	-1ʧܣ0ɹ
*/
int	app_wireless_pair_Init(void);

/**
	@brief 		עɨ
	@param 		cb								-	[in]	עĻص
	@return 						- [out]	-1ʧܣ0ɹ
*/
int	app_wireless_pair_Regist_SetScan(App_Wireless_Pair_Set_Scan_Cb cb);

/**
	@brief 		ע㲥
	@param 		cb								-	[in]	עĻص
	@return 						- [out]	-1ʧܣ0ɹ
*/
int	app_wireless_pair_Regist_SetAdv(App_Wireless_Pair_Set_Adv_Cb cb);

/**
	@brief 		ɨ
	@param 		rssi							-	[in]	źǿ
	@param 		addr							-	[in]	MACַָ
	@return 						- [out]	-1ʧܣ0ɹ
*/
int	app_wireless_pair_Scan_Req(int rssi, uint8_t *addr);

/**
	@brief 		ɨظ
	@param 		rssi							-	[in]	źǿ
	@param 		addr							-	[in]	MACַָ
	@return 						- [out]	-1ʧܣ0ɹ
*/
int	app_wireless_pair_Scan_Rsp(int rssi, uint8_t *addr);

/**
	@brief 		
	@param 		
	@return 						- [out]	-1ʧܣ0ɹ
*/
int	app_wireless_pair_start_led(void);

/**
	@brief 		
	@param 		
	@return 						- [out]	-1ʧܣ0ɹ
*/
int	app_wireless_pair_stop_led(void);

/**
	@brief 		¼
	@param 		event							-	[in]	¼
	@return 						- [out]	-1ʧܣ0ɹ
*/
int	app_wireless_pair_EventHandle(App_Wireless_Pair_Event_e  event);

App_Wireless_Pair_State_e app_wireless_pair_get_curstate(void);

#ifdef __cplusplus
}
#endif

#endif








