/** @file
 *
 * @API ĵ
 *
 */

#ifndef __BLE_COMM__
#define __BLE_COMM__

#include "sdk_common.h"
#include "ble_db_discovery.h"
#include "sdk_errors.h"
#include "app_error.h"
#include "app_util.h"
#include "bsp_btn_ble.h"
#include "ble.h"
#include "ble_gap.h"
#include "ble_hci.h"
#include "nrf_sdh.h"
#include "nrf_sdh_ble.h"
#include "nrf_sdh_soc.h"
#include "ble_nus_c.h"
#include "nrf_ble_gatt.h"
#include "nrf_pwr_mgmt.h"
#include "nrf_ble_scan.h"
#include "app_timer.h"
#include "ble_conn_state.h"

#include "SEGGER_RTT.h"
#include "nrf_delay.h"
#include "main.h"
#include "queue.h"
#include "ringframe.h"
#include "ble_advdata.h"

// <<< Use Configuration Wizard in Context Menu >>>\r\n
#define APP_BLE_CONN_CFG_TAG 1

// <q> USE_LADDR  - 㲥Ƿӵַ׺
#ifndef USE_LADDR
#define USE_LADDR 1
#endif
// <q> USENAMEFR  - ɨǷƥ
#ifndef USENAMEFR
#define USENAMEFR 1
#endif
// <q> USEMACNAME  - macַΪ
#ifndef USEMACNAME
#define USEMACNAME 0
#endif

// <q> USEFIFO  - FIFOʽ
#ifndef USEFIFO
#define USEFIFO 1
#endif

#define TARFET_LEN_MAX NRF_BLE_SCAN_NAME_MAX_LEN

// <q> BLE_PRINTF  - Ϣ
#ifndef BLE_PRINTF
#define BLE_PRINTF 0
#endif
#if BLE_PRINTF
#define BLE_PRINT(...) DEBUG_LOG( __VA_ARGS__)
#else
#define BLE_PRINT(...) ;
#endif
#define APP_ERR_BASE 0

/**@brief ִ. */
enum
{
	APP_SUCCESS = APP_ERR_BASE,
	APP_ERR_DISCONN,
	APP_ERR_CONNECTED,
	APP_ERR_PARAMERR,
	APP_ERR_OVERLENGTH,
	APP_ERR_BUSY,
	APP_ERROR_RESOURCES,
};

/**@brief .
 *
 * @param[in]      err_num       	 
 *
 * @warning 
 */
void err(int err_num);

/**@brief ɨ赽Ĺ㲥ݰص¼
 *
 * @param[in]      unsigned short   㲥ݰĳ
 * @param[out]     unsigned char *  յ㲥ݰָ
 * @param[in]      signed char      RSSI
 *
 * @warning 
 */
typedef void (*advdata_rep_handler_t)(ble_gap_evt_adv_report_t const * p_adv_report);

/**@brief ݽ
 *
 * @warning 
 */
typedef void (*Ble_receive_handler_t)(unsigned char *, int);

/**@brief ʱص
 *
 * @warning 
 */
typedef void (*Ble_evt_cb)(void);

/**@brief ݵӻ
 *
 * @param[in]      bytes       Ҫ͵ݵָ.
 * @param[in]      len  			 Ҫ͵ݵĳ
 *
 * @retval 0  			ɹ
 * @retval 1 				ʧ
 *
 * @warning 
 */
unsigned int send_bytes_server(uint8_t *bytes, uint16_t len);

/**@brief ݵ
 *
 * @param[in]      bytes       Ҫ͵ݵָ.
 * @param[in]      len  			 Ҫ͵ݵĳ
 *
 * @retval 0  			ɹ
 * @retval 1 				ʧ
 *
 * @warning 
 */
unsigned int send_bytes_client(unsigned char *bytes, uint16_t len);

/**@brief ʼ
 *
 * @warning 
 */
void host_init(Ble_receive_handler_t receive_handler);

/**@brief ӻʼ
 *
 * @warning 
 */
void slave_init(Ble_receive_handler_t receive_handler);

/**@brief ӻɫȡǷ
 *
 * @retval 1   Ѿ
 * @retval 0   δ
 *
 * @warning 
 */
unsigned char slave_isconnect(void);

/**@brief ɫȡǷ
 *
 * @retval 1   Ѿ
 * @retval 0   δ
 *
 * @warning 
 */
unsigned char host_isconnect(void);

/**@brief ɨ
 *
 * @param[in]      name      Ҫõ
 * @param[in]      len       ҪõƵĳ
 *
 * @retval APP_SUCCESS            ɹ
 * @retval APP_ERR_CONNECTED      Ѿ
 * @retval APP_ERR_OVERLENGTH     ̫
 *
 * @warning 
 */
unsigned int host_set_scan_name(char *name, int len);

/**@brief ù㲥
 *
 * @param[in]      name      ҪõĹ㲥
 * @param[in]      len       ҪõĹ㲥Ƶĳ
 *
 * @retval APP_SUCCESS            ɹ 
 *
 * @warning 
 */
unsigned int slave_set_adv_name(char *name, int len);

/**@brief ȡǰڹ㲥Ƴ
 *
 * @param[out]     len  					 㲥Ƴ
 *
 * @warning 
 */
void slave_get_advname_len(int *len);

/**@brief ȡǰڹ㲥ƣҪvoid slave_get_advname_len(int *len);
 *
 * @param[in]      len    㲥Ƶĳ
 * @param[out]     name   㲥
 *
 * @warning 
 */
void slave_get_advname(char *name, int len);

/**@brief עһӽʱ֪ͨ
 *
 * @param[in]      cb       ҪעĻصָ
 *
 * @retval -1     ҪעĻصѾ
 * @retval 0 			עɹ
 * @retval -2     עĶѾ
 *
 * @warning 
 */
int Ble_Host_Connectd_Evt_Regist(Ble_evt_cb cb);

/**@brief עһӶϿʱ֪ͨ
 *
 * @param[in]      cb       ҪעĻصָ
 *
 * @retval -1     ҪעĻصѾ
 * @retval 0 			עɹ
 * @retval -2     עĶѾ
 *
 * @warning 
 */
int Ble_Host_Disconn_Evt_Regist(Ble_evt_cb cb);

/**@brief עһӽʱ֪ͨ
 *
 * @param[in]      cb       ҪעĻصָ
 *
 * @retval -1     ҪעĻصѾ
 * @retval 0 			עɹ
 * @retval -2     עĶѾ
 *
 * @warning 
 */
int Ble_Slave_Connectd_Evt_Regist(Ble_evt_cb cb);

/**@brief עһӶϿʱ֪ͨ
 *
 * @param[in]      cb       ҪעĻصָ
 *
 * @retval -1     ҪעĻصѾ
 * @retval 0 			עɹ
 * @retval -2     עĶѾ
 *
 * @warning 
 */
int Ble_Slave_Disconn_Evt_Regist(Ble_evt_cb cb);

/**@brief ΪʱӼ
 *
 * @param[in]      min_conn_interval   СӼ
 * @param[in]      max_conn_interval   Ӽ
 *  
 * @retval APP_ERR_PARAMERR   Ĳ
 * @retval APP_ERR_DISCONN    ѾϿ
 *
 * @warning 
 */
unsigned int Ble_update_conn_interval(float min_conn_interval, float max_conn_interval);

/**@brief ΪӻʱӼ
 *
 * @param[in]      min_conn_interval   СӼ
 * @param[in]      max_conn_interval   Ӽ
 *
 * @retval APP_ERR_BUSY       һУʱµ     
 * @retval APP_ERR_PARAMERR   Ĳ
 * @retval APP_ERR_DISCONN    ѾϿ
 *
 * @warning 
 */
unsigned int slave_update_conn_interval_request(float min_conn_interval, float max_conn_interval);

/**@brief رչ㲥
 *
 * @warning 
 */
void advertising_stop(void);

/**@brief 㲥
 *
 * @warning 
 */
void advertising_start(void);

/**@brief ɨ
 *
 * @warning 
 */
void scan_start(void);

//صɨֱӵ  void nrf_ble_scan_stop(void);

/**@brief 
 *
 * @warning 
 */
uint8_t Slave_Get7_5ms_interval(void);

/**@brief ΪӻɫʱϿ
 *
 * @warning 
 */
void slave_disconnect(void);

/**@brief ΪɫʱϿ
 *
 * @warning 
 */
void host_disconnect(void);

/**@brief ΪӻɫʱȡӲ
 *
 * @param[out]     p  ȡӲĴָ
 *
 * @warning 
 */
void slave_get_conn_params(ble_gap_conn_params_t *p);

/**@brief ΪɫʱȡӲ
 *
 * @param[out]     p  ȡӲĴָ
 *
 * @warning 
 */
void host_get_conn_params(ble_gap_conn_params_t *p);

/**@brief ӻ㲥ʼ
 * @warning 
 */
void slave_adv_init(void);

/**@brief ΪӻɫʱȡRSSI
 *
 * @retval ȡRSSI  
 *
 * @warning 
 */
signed char slave_get_rssi(void);

/**@brief ΪɫʱȡRSSI
 *
 * @retval ȡRSSI  
 *
 * @warning 
 */
signed char host_get_rssi(void);

/**@brief ˶㷨
 *
 * @param[in]      IS_HOST     ǷЬ.
 * @param[in]      time_stamp  ʱ.
 * @param[in]      _acc        ٶ.
 * @param[in]      _gry        .
 * @param[in]      front_mag   ǰ.
 * @param[in]      back_mag    .
 * @param[in]      _rssi       źǿ.
 *
 * @warning 
 */
void IMU_Process_motion_queue(uint8_t IS_HOST, int32_t time_stamp, int16_t* _acc,int16_t* _gry, int16_t* front_mag, int16_t* back_mag, uint8_t _rssi);

/**@brief 빦
 *
 * @details 
 * @warning 
 */
void IMU_Rec_data(uint8_t* pdat,uint8_t len);

/**@brief IMU_Dtalige 뺯
 * @warning 
 */
void IMU_Dtalige(void);

/**@brief ԭʼϴģʽ
 * @warning 
 */
void IMU_Dtalige_Rowdata_ON(void);

/**@brief رԭʼϴģʽ
 * @warning 
 */
void IMU_Dtalige_Rowdata_OFF(void);

/**@brief ϵͳѭе
 *
 * @warning 
 */
void send_bytes_client_pcs(void);

/**@brief Function for searching through encoded Advertising data for a complete local name.
 *
 * @param[in]    p_encoded_data Data buffer containing the encoded Advertising data.
 * @param[in]    data_len       Length of the data buffer \p p_encoded_data.
 * @param[in]    p_target_name  Name to search for.
 *
 * @retval true   If \p p_target_name was found among \p p_encoded_data, as a complete local name.
 * @retval false  If \p p_target_name was not found among \p p_encoded_data, or if \p p_encoded_data
 *                or \p p_target_name was NULL.
 */
bool advdata_name_find(uint8_t const * p_encoded_data,
                           uint16_t        data_len,
                           char    const * p_target_name);

/**@brief Function for searching through encoded Advertising data for a device shortened name.
 *
 * @param[in]    p_encoded_data     Data buffer containing the encoded Advertising data.
 * @param[in]    data_len           Length of the data buffer \p p_encoded_data.
 * @param[in]    p_target_name      Name to search for.
 * @param[in]    short_name_min_len Minimum length of the shortened name.
 *               For example, if the advertising data has a shortened name 'No' and this parameter is
 *               set to 4 with a target_name set to Nordic_XXX it will return false, but if
 *               the shortened name in the advertising data is 'Nord', it will return true.
 * @note: If the shortened name in the Advertising data has the same length as the target name,
 *        this function will return false, since this means that the complete name is actually
 *        longer, thus different than the target name.
 *
 * @retval true   If \p p_target_name was found among \p p_encoded_data, as short local name.
 * @retval false  If \p p_target_name was not found among \p p_encoded_data, or if \p p_encoded_data
 *                or \p p_target_name was NULL.
 */
bool advdata_short_name_find(uint8_t const * p_encoded_data,
                                 uint16_t        data_len,
                                 char    const * p_target_name,
                                 uint8_t const   short_name_min_len);
																 
/**@brief עյ㲥ݰʱ¼.
 *
 * @param[in]   handler     ҪעĻصĺָ
 *
 * @note: 			˺ÿεöḲһεעhandlerֻһΣעɹÿյ㲥ݰԺ¼ص
 *
 */
void advdata_report_Evt_Regist(advdata_rep_handler_t handler);
																 
/**@brief رɨ
 * @warning 
 */																 
void ST_scan_stop(void);

/**@brief ɨ
 * @warning 
 *
 * @retval APP_ERROR_RESOURCES   radioռù࣬ȹرһ·ٴ򿪾ͺ   
 * @retval APP_SUCCESS           ɹ
 *  			
 * @note:
 */
unsigned int ST_scan_start(void);																 

/**@brief ȡmacַ,*macṩڴ泤ȱ6ֽڷڴ
 * @warning 
 *  			
 * @note:
 */
void Get_MACaddr(unsigned char *mac);	

/**@brief ӳɹȡԷĵַ
 * @warning 
 *  			
 * @retval Էַ
 */
uint8_t * HostConnted_peer_addr(void);

/**@brief ӻӳɹȡԷĵַ
 * @warning 
 *  			
 * @retval Էַ
 */
uint8_t * ClientConnted_peer_addr(void);

void SetScanResponse(uint8_t charge,uint8_t config);

void advdata_report_Evt_del(advdata_rep_handler_t handler);

#endif
