#ifndef __DRV_QMA7981_H__
#define __DRV_QMA7981_H__

#ifdef __cplusplus
extern "C" {
#endif

/*Includes ------------------------------------------------------*/
#include <stdint.h>
#include <stdio.h>
#include <stdbool.h>

/*STRUCTION -----------------------------------------------------*/
typedef enum{
	QMA_ACC_ODR_OFF   					= 0x00,																								//رռٶ
	
	QMA_ACC_ODR_12HZ5 					= 0x01,																								//Ƶ - 12.5	
	
	QMA_ACC_ODR_104HZ 					= 0x02,																								//Ƶ - 104

} QMA_ACC_ODR_e;

typedef enum{
	QMA_ACC_FS_2G   						= 0x01,																								// - 2ٶ
	
	QMA_ACC_FS_16G   						= 0x02,																								// - 16ٶ
	
} QMA_ACC_FS_e;

typedef struct 
{
	QMA_ACC_ODR_e								acc_odr;																							//ٶȲƵ
	
	QMA_ACC_FS_e								acc_fs;																								//ٶ
	
} drv_qma_config_param_t;

typedef struct
{
	int16_t 										acc[3];																								//ٶ
	
} qma_data_t;

/*API -------------------------------------------------------*/
/**
	@brief 		ʼQMA
	@param 		
	@return 								- [out]	-1ʧܣ0ɹ
*/
int drv_qma_Init(void);
/**
	@brief 		QMAϵ
	@param 		
	@return 								- [out]	-1ʧܣ0ɹ
*/
int drv_qma_power_off(void);
/**
	@brief 		QMAϵ磨Ĭù
	@param 		
	@return 								- [out]	-1ʧܣ0ɹ
*/
int drv_qma_power_on(void);
/**
	@brief 		ACC
	@param 		acc_fs 								- [in]	ACC
	@return 								- [out]	-1ʧܣ0ɹ
*/
int	drv_qma_set_acc_fs(QMA_ACC_FS_e acc_fs);
/**
	@brief 		ACCƵ
	@param 		acc_odr 							- [in]	ACCƵ
	@return 								- [out]	-1ʧܣ0ɹ
*/
int	drv_qma_set_acc_odr(QMA_ACC_ODR_e acc_odr);
/**
	@brief 		ȡQMAò
	@param 		param 								- [in]	QMAò
	@return 								- [out]	-1ʧܣ0ɹ
*/
int	drv_qma_get_config_param(drv_qma_config_param_t	*p_param);
/**
	@brief 		ȡQMAACC
	@param 		p_data 								- [out]	صACC
	@return 								- [out]	-1ʧܣ0ɹ
*/
int	drv_qma_get_acc_data(qma_data_t	*p_data);


#ifdef __cplusplus
}
#endif

#endif




















