//=============================================================================================
// MahonyAHRS.h
//=============================================================================================
//
// Madgwick's implementation of Mayhony's AHRS algorithm.
// See: http://www.x-io.co.uk/open-source-imu-and-ahrs-algorithms/
//
// Date			Author			Notes
// 29/09/2011	SOH Madgwick    Initial release
// 02/10/2011	SOH Madgwick	Optimised for reduced CPU load
//
//=============================================================================================
#ifndef _hal_ano_h
#define _hal_ano_h
#include <stdbool.h>
#include <stdint.h>
#include <string.h>
#include "sdk_common.h"
#include "SEGGER_RTT.h"
#include "usr_config.h"

#define ANO_COM_USR1	0xF1
#define ANO_COM_USR2	0xF2
#define ANO_COM_USR3	0xF3
#define ANO_COM_USR4	0xF4
#define ANO_COM_USR5	0xF5
#define ANO_COM_USR6	0xF6
#define ANO_COM_USR7	0xF7
#define ANO_COM_USR8	0xF8
#define ANO_COM_USR9	0xF9
#define ANO_COM_USR10	0xFA



void ANO_Send_Status(float rol,float pit,float yaw,int32_t hight,int8_t mode,int8_t lock,int8_t link);
void ANO_Send_Senser(int16_t ax, int16_t ay, int16_t az, int16_t gx, int16_t gy, int16_t gz, int16_t mx, int16_t my, int16_t mz);
void ANO_Send_RCData(int16_t thr, int16_t yaw, int16_t rol, int16_t pit, int16_t aux1, int16_t aux2, int16_t aux3, int16_t aux4, int16_t aux5, int16_t aux6);
void ANO_Send_Distance(uint8_t num,int16_t dis1_100,int16_t dis2_100,int16_t dis3_100,int16_t dis4_100,int16_t dis5_100,int16_t dis6_100);
void ANO_Send_Location(uint8_t num,int16_t locX_100,int16_t locY_100,int16_t locZ_100,int16_t locDX_100,int16_t locDY_100,int16_t locDZ_100);


#endif
