/*Includes ----------------------------------------------*/
#include "nrf_delay.h"
#include "nrf_strerror.h"
#include "ble_comm.h"
#include "exception.h"
#include "system.h"
#include "bsp_time.h"
#include "bsp_wdt.h"
#include "hal_led.h"
#include "hal_ble_client.h"
#include "hal_ble_host.h"
#include "app_flash.h"
#include "app_error.h"
#include "app_client.h"
#include "app_flash.h"
#include "app_util_platform.h"
#include "bll_imu.h"
#include "app_detectIsHost.h"

/*Private macro ------------------------------------------------*/
#define EXCEPT_LED_ON_ACC_Z								1500																	//ٶZᴥ쳣ƿ
#define EXCEPT_LED_OFF_ACC_Z							-1500																	//ٶZᴥ쳣ƹر
#define LED_PROCESS_CYCLE									200																		//쳣߳,msΪλ
#define EXCEPT_LED_TOGGLE_TIME						200																		//쳣Ʒת,msΪλ
#define EXCEPT_LED_DISPLAY_TIME						10000																	//쳣ʾʱ,msΪλ
#define UNKOWN_RESET_INFO_SEND_CYCLE			100																		//δ֪쳣Ϣ߳,msΪλ
#define	EXCEPT_NO_INIT_DATA_CHANGE_FLAG		0x01																	//ı־λÿ޸Ľṹ壬Ҫ1
#define __NO_INIT__ 									__attribute__((at(0x2000FFA0)))

/*STRUCTION ----------------------------------------------------*/
//ԭ£쳣ʱӲὫһЩCPUļĴ浽ջУͨ쳣ʱȡջָSPֵͨSPȡǰջλãȻȡ쳣֮ǰPCֵָ֪쳣λˡ
//CPUĴջе
//ջݶ
typedef struct
{
	uint32_t R0;
	uint32_t R1;
	uint32_t R2;
	uint32_t R3;
	uint32_t R12;
	uint32_t LR;
	uint32_t PC;
	uint32_t xPSR;
}STACK_DATA_TYPE;

typedef struct
{
	uint32_t wdt_remain_tim;																									//ϴιʣʱ䣬λms
	uint32_t thread_start_tim;
	uint32_t thread_end_tim;
}WDT_INFO_TYPE;

typedef struct
{
	char buff[28];
}APP_ERROR_CHECK_INFO_TYPE;

typedef struct _process_info
{
	STACK_DATA_TYPE 							stack;
	WDT_INFO_TYPE									wdt_info;
	APP_ERROR_CHECK_INFO_TYPE			app_error_check_info;
}Process_Info_t;

typedef enum{
	EXCEPT_LED_ON,																														//쳣 - 
	EXCEPT_LED_OFF,																														//쳣 - 
} EXCEPT_LED_SWITCH_e;

typedef enum{

	EXCEPT_UNKOWN_RESET_TRIGGER_WDT = 0,																			//쳣δ֪ԭ򡪡Ź
	
	EXCEPT_UNKOWN_RESET_TRIGGER_RUN_OUT,																			//쳣δ֪ԭ򡪡ܷ
	
	EXCEPT_UNKOWN_RESET_TRIGGER_APP_ERROR_CHECK,															//쳣APP_ERROR_CHECK
	
	EXCEPT_UNKOWN_RESET_TRIGGER_NUMS,																					//쳣δ֪ԭ򡪡
	
} EXCEPT_UNKOWN_RESET_TRIGGER_e;

typedef struct _except_unkown_reset_info
{
	Process_Info_t 										process_info;														//߳ϢջϢͿŹϢ
	uint32_t 													trigger;																//δ֪
	uint32_t													cur_process_id;													//ǰڴĽ̺
	uint32_t													end_process_id;													//Ľ̺
	uint8_t														is_upload;															//Ƿϴ
} Except_Unkown_Reset_Info_t;

typedef struct no_init
{
	Except_Unkown_Reset_Info_t				unkown_reset_info;
	uint32_t													struct_change_flag;											//ı־λ
} No_Init_t;

typedef struct exception{
	
	/*private member*/
	EXCEPT_LED_SWITCH_e  							led_switch;															//쳣ƿ
	
	uint16_t													led_display_time;												//쳣ʾʱ
	
	uint16_t													led_toggle_time;												//쳣Ʒתʱ	
	
	uint8_t														except_type[EXCEPT_NUM];								//쳣
	
	uint16_t													except_number_of_exist;									//Ѵڵ쳣
	
} Exception_t;

/*Local Variable ----------------------------------------------*/
static Exception_t 						ob_exception;

static volatile __NO_INIT__ No_Init_t 	no_init_data;

battercb_t	battery_record={0};

/*Local Functions ----------------------------------------------*/
//ûвϵͳʱ쳣
static void Except_NotOSHardFault_Handler(uint32_t msp_addr)
{
	STACK_DATA_TYPE *p;										//ջд洢
	
	msp_addr -= 4;												//ջָȥ4ΪĬ϶ջָָһյĵط-Աȥ4
	DEBUG_LOG("\r\n-----------------ERROR -----------------\r\nHardFault_Handler\r\n");
	
 
	if((msp_addr >> 20) != 0x200)		//жϵַΧ0x200xxxxx Χ
	{
		DEBUG_LOG("Warning: stack pointer is damaged, unable to record the scene!\r\n");
		return;
	}
	
	
	msp_addr += 8;												//жϺ󣬶ջֽ2u32ݣҪ
	
	no_init_data.unkown_reset_info.is_upload = 1;	
	
	no_init_data.unkown_reset_info.trigger |= (1<<EXCEPT_UNKOWN_RESET_TRIGGER_RUN_OUT);
	
	memcpy((void *)&no_init_data.unkown_reset_info.process_info.stack, (STACK_DATA_TYPE *)msp_addr, sizeof(STACK_DATA_TYPE));
	
	p = (STACK_DATA_TYPE *)msp_addr;
	p->PC -= 3;														//PCָҪȥ3
}

////вϵͳʱ쳣
//static void Except_OSHardFault_Handler(uint32_t psp_addr)
//{
//	STACK_DATA_TYPE *p;										//ջд洢
//	
//	psp_addr -= 4;												//ջָȥ4ΪĬ϶ջָָһյĵط-Աȥ4
//	DEBUG_LOG("\r\n-----------------ERROR -----------------\r\nHardFault_Handler\r\n");
//	
// 
//	if((psp_addr >> 20) != 0x200)		//жϵַΧ0x200xxxxx Χ
//	{
//		DEBUG_LOG("Warning: stack pointer is damaged, unable to record the scene!\r\n");
//		return;
//	}
//	
//	no_init_data.unkown_reset_info[EXCEPT_UNKOWN_RESET_TRIGGER_RUN_OUT].is_upload = true;
//	
//	no_init_data.unkown_reset_info[EXCEPT_UNKOWN_RESET_TRIGGER_RUN_OUT].trigger = EXCEPT_UNKOWN_RESET_TRIGGER_RUN_OUT;
//	
//	memcpy(&no_init_data.unkown_reset_info[EXCEPT_UNKOWN_RESET_TRIGGER_RUN_OUT].stack, (STACK_DATA_TYPE *)psp_addr, sizeof(STACK_DATA_TYPE));
//	
//	p = (STACK_DATA_TYPE *)psp_addr;
//	p->PC -= 3;												//PCָҪȥ3
//	
////	DEBUG_LOG("R0:0x%08X\r\n", p->R0);
////	DEBUG_LOG("R1:0x%08X\r\n", p->R1);
////	DEBUG_LOG("R2:0x%08X\r\n", p->R2);
////	DEBUG_LOG("R3:0x%08X\r\n", p->R3);
////	DEBUG_LOG("R12:0x%08X\r\n", p->R12);
////	DEBUG_LOG("LR:0x%08X\r\n", p->LR);
////	DEBUG_LOG("PC:0x%08X\r\n", p->PC);
////	DEBUG_LOG("xPSR:0x%08X\r\n", p->xPSR);
////	DEBUG_LOG("system reset...\r\n");
//}

static void Exception_Led_Process(void);

static void Except_Led_Close(void)
{
	//ȫʹر
	Process_SetHoldOn(Exception_Led_Process,0);
	ob_exception.led_switch = EXCEPT_LED_OFF;
	ob_exception.led_display_time = EXCEPT_LED_DISPLAY_TIME/LED_PROCESS_CYCLE;
	ob_exception.led_toggle_time = EXCEPT_LED_TOGGLE_TIME/LED_PROCESS_CYCLE;
	LED_Stop(LED_EXCEPT);
}
static void Except_Led_OpenOnce(void)
{
	//쳣ʾ/ر
	if(ob_exception.led_display_time != 0)
	{
		//ȫʿ
		Process_SetHoldOn(Exception_Led_Process,1);		
		
		if(ob_exception.led_toggle_time == 0)
		{
			if(ob_exception.led_switch == EXCEPT_LED_ON)ob_exception.led_switch = EXCEPT_LED_OFF;
			else ob_exception.led_switch = EXCEPT_LED_ON;
			
			ob_exception.led_toggle_time = EXCEPT_LED_TOGGLE_TIME/LED_PROCESS_CYCLE;
		}
		else
		{
			if(ob_exception.led_switch == EXCEPT_LED_ON)LED_Start(LED_EXCEPT,COLOR_ORANGE);
			if(ob_exception.led_switch == EXCEPT_LED_OFF)LED_Start(LED_EXCEPT,COLOR_BLACK);
			ob_exception.led_toggle_time--;
		}
		
		ob_exception.led_display_time--;
	}
}
static void Exception_Led_Process(void)
{
	int16_t f_acc[3];
	bll_imu_data_t data;
	//ȡACCֵ
	if(bll_imu_get_data_num(BLL_IMU_DIR_FRONT) >= 1){
		bll_imu_get_data(BLL_IMU_DIR_FRONT, 0, &data);
		f_acc[0] = data.acc[0];f_acc[1] = data.acc[1];f_acc[2] = data.acc[2];
	}
	else return;
	
	//ЬӵתƽţҴ쳣
	if(f_acc[2] >= EXCEPT_LED_ON_ACC_Z && ob_exception.except_number_of_exist > 0)
	{
		Except_Led_OpenOnce();
	}//Ь
	else if(f_acc[2] <= EXCEPT_LED_OFF_ACC_Z)
	{
		Except_Led_Close();
	}
}

static void Exception_UnkownReset_Info_Send_Process(void)
{
	uint32_t tim;
	char buf[250]={0};
	memset(buf,0,sizeof(buf));

	if(no_init_data.unkown_reset_info.is_upload == 1)
	{
		if((no_init_data.unkown_reset_info.trigger & (1<<EXCEPT_UNKOWN_RESET_TRIGGER_WDT)) != 0)
		{
			tim = no_init_data.unkown_reset_info.process_info.wdt_info.thread_end_tim;
			if(tim < no_init_data.unkown_reset_info.process_info.wdt_info.thread_start_tim)tim += 16777216;
			
			sprintf(buf,"id:0x%x,0x%x,%d,%f\r\n",no_init_data.unkown_reset_info.cur_process_id,no_init_data.unkown_reset_info.end_process_id, \
																		no_init_data.unkown_reset_info.process_info.wdt_info.wdt_remain_tim, \
																		(tim-no_init_data.unkown_reset_info.process_info.wdt_info.thread_start_tim)/32.768);
			if(Except_TxError(EXCEPT_UNKOWN_RESET,buf) == 0)
			{
				no_init_data.unkown_reset_info.trigger &= ~(1<<EXCEPT_UNKOWN_RESET_TRIGGER_WDT);
				if(no_init_data.unkown_reset_info.trigger == 0)no_init_data.unkown_reset_info.is_upload = 0;
			}
		}
		else if((no_init_data.unkown_reset_info.trigger & (1<<EXCEPT_UNKOWN_RESET_TRIGGER_RUN_OUT)) != 0)
		{
			sprintf(buf,"id:0x%x,0x%x,R:0x%x,0x%x,0x%x,0x%x,0x%x,0x%x,0x%x,0x%x,H:0x%x,S:0x%x\r\n",	no_init_data.unkown_reset_info.cur_process_id,no_init_data.unkown_reset_info.end_process_id, \
																																					no_init_data.unkown_reset_info.process_info.stack.R0, \
																																					no_init_data.unkown_reset_info.process_info.stack.R1, \
																																					no_init_data.unkown_reset_info.process_info.stack.R2, \
																																					no_init_data.unkown_reset_info.process_info.stack.R3, \
																																					no_init_data.unkown_reset_info.process_info.stack.R12, \
																																					no_init_data.unkown_reset_info.process_info.stack.LR, \
																																					no_init_data.unkown_reset_info.process_info.stack.PC - 3, \
																																					no_init_data.unkown_reset_info.process_info.stack.xPSR,
																																					HARDWARE_VERSION,SOFTWARE_VERSION);
			if(Except_TxError(EXCEPT_UNKOWN_RESET,buf) == 0)
			{
				no_init_data.unkown_reset_info.trigger &= ~(1<<EXCEPT_UNKOWN_RESET_TRIGGER_RUN_OUT);
				if(no_init_data.unkown_reset_info.trigger == 0)no_init_data.unkown_reset_info.is_upload = 0;
			}
		}
		else if((no_init_data.unkown_reset_info.trigger & (1<<EXCEPT_UNKOWN_RESET_TRIGGER_APP_ERROR_CHECK)) != 0)
		{
			sprintf(buf,"id:0x%x,0x%x,%s",no_init_data.unkown_reset_info.cur_process_id,no_init_data.unkown_reset_info.end_process_id,no_init_data.unkown_reset_info.process_info.app_error_check_info.buff);
			if(Except_TxError(EXCEPT_UNKOWN_RESET,buf) == 0)
			{
				no_init_data.unkown_reset_info.trigger &= ~(1<<EXCEPT_UNKOWN_RESET_TRIGGER_APP_ERROR_CHECK);
				if(no_init_data.unkown_reset_info.trigger == 0)no_init_data.unkown_reset_info.is_upload = 0;
			}
		}
		else
		{
			//ܷݱ۸
			memset((void*)&no_init_data, 0 , sizeof(No_Init_t));
			no_init_data.struct_change_flag = EXCEPT_NO_INIT_DATA_CHANGE_FLAG;
			no_init_data.unkown_reset_info.is_upload = 0;
		}
	}
}

/*API ----------------------------------------------*/

/**
	@brief 		עЬϢĻص
	@param 		Handle
	@return 	
*/
void cb_BLE_Host_R_ERR(void* handle)
{
	BLE_Host_Rx_t* target = handle;
	BLE_Client_Tx_Send(0,BLE_ERR,target->pDat,target->datLen);
}

void Exception_Init(void)
{
	//ṹ屻Ķá
	if(no_init_data.struct_change_flag != EXCEPT_NO_INIT_DATA_CHANGE_FLAG)
	{
		memset((void*)&no_init_data, 0 , sizeof(No_Init_t));
		no_init_data.struct_change_flag = EXCEPT_NO_INIT_DATA_CHANGE_FLAG;
		no_init_data.unkown_reset_info.is_upload = 0;
	}

	memset(&ob_exception, 0 , sizeof(ob_exception));
	ob_exception.led_switch = EXCEPT_LED_OFF;
	ob_exception.led_display_time = EXCEPT_LED_DISPLAY_TIME/LED_PROCESS_CYCLE;
	ob_exception.led_toggle_time = EXCEPT_LED_TOGGLE_TIME/LED_PROCESS_CYCLE;
	
	Process_Start(LED_PROCESS_CYCLE,"Exception_Led",Exception_Led_Process);
	
	Process_Start(UNKOWN_RESET_INFO_SEND_CYCLE,"Exception_UnkownReset",Exception_UnkownReset_Info_Send_Process);
	
	BLE_Host_Rx_Regist(BLE_ERR,cb_BLE_Host_R_ERR);
	
	memcpy(&battery_record,&mFlash.mbattercb_t,sizeof(battercb_t));
	
}

/**
	@brief 		ϵͳص
  @param 		id: 
	@return 	
*/
void app_error_fault_handler(uint32_t id, uint32_t pc, uint32_t info)
{
	char err_info[200];
	
	Flash_SaveLog(id,pc,info);
	DEBUG_LOG("app_error_fault_handler,System reset\n");
	
	no_init_data.unkown_reset_info.is_upload = 1;
	no_init_data.unkown_reset_info.trigger |= (1<<EXCEPT_UNKOWN_RESET_TRIGGER_APP_ERROR_CHECK);
	memset((void *)&no_init_data.unkown_reset_info.process_info.app_error_check_info, 0, sizeof(APP_ERROR_CHECK_INFO_TYPE));
	switch (id)
	{
		#if defined(SOFTDEVICE_PRESENT) && SOFTDEVICE_PRESENT
		case NRF_FAULT_ID_SD_ASSERT:
			memcpy((void *)&no_init_data.unkown_reset_info.process_info.app_error_check_info,"SD: ASSERTION FAILED\r\n",sizeof(APP_ERROR_CHECK_INFO_TYPE));
		break;
		case NRF_FAULT_ID_APP_MEMACC:
			memcpy((void *)&no_init_data.unkown_reset_info.process_info.app_error_check_info,"SD: INVALID MEMORY ACCESS\r\n",sizeof(APP_ERROR_CHECK_INFO_TYPE));
		break;
		#endif
		case NRF_FAULT_ID_SDK_ASSERT:
		{
			assert_info_t * p_info = (assert_info_t *)info;
			sprintf((char *)err_info,"f:%s,l:%u\r\n",
			p_info->p_file_name+13,
			p_info->line_num);
			memcpy((void *)&no_init_data.unkown_reset_info.process_info.app_error_check_info,err_info,sizeof(APP_ERROR_CHECK_INFO_TYPE));
			break;
		}
		case NRF_FAULT_ID_SDK_ERROR:
		{
			error_info_t * p_info = (error_info_t *)info;
			sprintf((char *)err_info,"e:%u,f:%s,l:%u\r\n",
			p_info->err_code,
			p_info->p_file_name+13,
			p_info->line_num);
			memcpy((void *)&no_init_data.unkown_reset_info.process_info.app_error_check_info,err_info,sizeof(APP_ERROR_CHECK_INFO_TYPE));
		break;
		}
		default:
		sprintf((char *)err_info,"UNKNOWN FAULT 0x%08X\n", pc);
		memcpy((void *)&no_init_data.unkown_reset_info.process_info.app_error_check_info,err_info,sizeof(APP_ERROR_CHECK_INFO_TYPE));
		break;
	}

	NVIC_SystemReset();                                //λ	
}


int Except_TxError(ExcepType_t excep_type,const char *errstr){
	
	uint8_t buf[250];
	uint8_t L=0;
	uint16_t err_strlen =0;
	err_strlen = strlen(errstr);
	if(err_strlen > (sizeof(buf)-2))return -1;
	if(app_Get_isHost())buf[L++] =0;//0Ь1Ь
	else buf[L++] =1;
	buf[L++] = excep_type;		  	//
	
	memcpy(&buf[L],errstr,err_strlen);
	L +=err_strlen;
	
	return BLE_Client_Send(BLE_ERR,buf,L);
}

void Except_SetExceptype(ExcepType_t excep_type)
{
	if(ob_exception.except_type[excep_type] != 1)
	{
		ob_exception.except_type[excep_type] = 1;
		ob_exception.except_number_of_exist++;
	}
}

void Except_ClearExceptype(ExcepType_t excep_type)
{
	if(ob_exception.except_type[excep_type] == 1)
	{
		ob_exception.except_type[excep_type] = 0;
		if(ob_exception.except_number_of_exist != 0)ob_exception.except_number_of_exist--;
	}
}

bool Except_IsError(ExcepType_t excep_type)
{
	if(ob_exception.except_type[excep_type] == 1)
	{
		return true;
	}
	
	return false;
}

//Ӳж
void HardFault_Handler (void)
{
	uint32_t msp_addr = __get_MSP();		//ȡ߳ģʽ¶ջָλ
	uint32_t psp_addr = __get_PSP();		//ȡжµĶջָλ-OS
	
#if(UCOS_II_EN)						//ʹ˲ϵͳһ궨壬Լȥ
	if(SYS_GetOsStartup())			//ϵͳ-Լһ״̬ԻȡϵͳǷ
	{
		Except_OSHardFault_Handler(psp_addr);
	}
	else
	{
		Except_NotOSHardFault_Handler(msp_addr);
	}
#else //ûʹܲϵͳ
	Except_NotOSHardFault_Handler(msp_addr);	
#endif //UCOS_II_EN
	
	nrf_delay_ms(10); 					//ʱһ£ֹٶ̫
	
	NVIC_SystemReset();				//λ	
}

void Except_Get_Cur_Porcess_ID(uint32_t cur_process_id)
{
	uint32_t cur_tim,feed_watchdogtim;

	if(no_init_data.unkown_reset_info.is_upload == 0)
	{
		no_init_data.unkown_reset_info.cur_process_id = cur_process_id;
		cur_tim 					= NRF_RTC0->COUNTER;
		feed_watchdogtim 	= Get_FeedWatchDogTime();
		if(cur_tim<feed_watchdogtim) cur_tim += 16777216;
		no_init_data.unkown_reset_info.process_info.wdt_info.wdt_remain_tim = WDT_RELOAD_VALUE - ((cur_tim-feed_watchdogtim)/32.768);
		no_init_data.unkown_reset_info.process_info.wdt_info.thread_start_tim = cur_tim;
	}
}

void Except_Get_End_Porcess_ID(uint32_t end_process_id)
{
	if(no_init_data.unkown_reset_info.is_upload == 0)
	{
		no_init_data.unkown_reset_info.end_process_id = end_process_id;
	}
}

void Except_Unkown_Reset_WDT_Set(void)
{
	no_init_data.unkown_reset_info.is_upload = 1;
	no_init_data.unkown_reset_info.trigger |= (1<<EXCEPT_UNKOWN_RESET_TRIGGER_WDT);
	no_init_data.unkown_reset_info.process_info.wdt_info.thread_end_tim = NRF_RTC0->COUNTER;
}

/**
	@brief 		ȡ¼ַ
	@return   ¼ַ
*/

battercb_t* Except_Get_Battery_Record_Buff(void)
{
	return &battery_record;
}


















